-- DebuffCaster r33 - oblind
-- r33 - 2011-12-17
-- r1 - 2007-10-1

local buffs, debuffs, refresh, stack, data
stack = {
	{-- Spell Damage Taken (8%)
		1490,	-- Curse of the Elements 元素诅咒
		85547, -- Jinx: Curse of the Elements 灾星：元素诅咒
		58410, -- Master Poisoner 奇毒
		51160, -- Ebon Plaguebringer 黑色热疫使者
		48506, -- Earth and Moon 大地与月亮
		34889, -- Fire Breath 火焰吐息
		24844, -- Lightning Breath 闪电吐息
	},
	{-- Bleed Damage Taken (30%)
		33878, -- Mangle(bear) 裂伤（熊）
		33876, -- Mangle(cat) 裂伤（豹）
		16511, -- Hemorrhage 出血
		46856, -- Trauma 创伤
		50271, -- Tendon Ripe 裂筋
		35290, -- Gore 撞击
		57386, -- Stampede 突奔
	},
	{-- Reduced Casting Speed (30%)
		1714, -- Curse of Tongues 语言诅咒
		5761, -- Mind-Numbing Poison 麻痹毒药
		31589, -- Slow 减速
		73975, -- Necrotic Strike 死疽打击
		50274, -- Spore Cloud 孢子云雾
		58604 -- Lava Breath 熔岩吐息
	},
	{-- Reduced Armor (12%)
		7386, -- Sunder Armor
		20243, -- Devastate
		8647, -- Expose Armor
		770, -- Faerie Fire
		16857, -- Faerie Fire(feral)
		91565, -- Faerie Fire (the actual debuff)
		35387, -- Corrosive Spit (pet ability)
		50498 -- Tear Armor (pet ability)
	},
	{-- Reduced Healing (25%)
		12294, -- Mortal Strike
		46910, -- Furious Attacks
		15313, -- Improved Mind Blast
		13219, -- Wound Poison
		82654, -- Widow Venom
		30213, -- Legion Strike (felguard ability)
		54680 -- Monstrous Bite (exotic pet ability)
	},
	{-- Physical Damage Done (10%)
		702, -- Curse of Weakness
		99, -- Demoralizing Roar
		50256, -- Demoralizing Roar (pet ability)
		1160, -- Demoralizing Shout
		81130, -- Scarlet Fever
		26017 -- Vindication
	},
	{-- Reduced Attack Speed (20%)
		6343, -- Thunder Clap
		8042, -- Earth Shock
		54404, -- Dust Cloud (Tallstrider)
		55095, -- Frost Fever
		58180, -- Infected Wounds
		42231, -- Hurricane
		90315 -- Tailspin (Fox)
	},
	{-- Spell Crit Taken (5%)
		686, -- Shadow Bolt
		17800, -- Shadow and Flame
		22959, -- Critical Mass
		2948 -- Scorch
	},
}
data = {
	["DEATHKNIGHT"] = {
		buffs = {
			57330,	--Horn of Winter 寒冬号角
		},
		debuffs = {},
		refresh = {},
	},
	["DRUID"] = {
		buffs = {
			774,	--Rejuvenation 回春术
			8936,	--Regrowth 愈合
			33763,	--Lifebloom 生命绽放
			52610,	--Savage Roar 野蛮咆哮
			80951,	--Pulverize 粉碎
		},
		debuffs = {
			99,		--Demoralizing Roar 挫志咆哮
			339,	--Entangling Roots 根须缠绕
			770,	--Faerie Fire 精灵之火
			16857,	--Faerie Fire (Feral) 精灵之火（野性）
			5570,	--Insect Swarm 虫群
			8921,	--Moonfire 月火术
			33745, --Lacerate 割伤
			1079,	--Rip 割裂
			1822,	--Rake 斜掠
			33876,	--Mangle (Cat) 裂伤 - 豹
			33878,	--Mangle (Bear) 裂伤 - 熊
			93402,	--Sunfire 日炎术
		},
		refresh = {33763, 1079},
	},
	["HUNTER"] = {
		buffs = {
		},
		debuffs = {
			1130,	--Hunter's Mark 猎人印记
			1978,	--Serpent Sting 毒蛇钉刺
			2974,	--Wing Clip 摔拌
			5116,	--Concussive Shot 震荡射击
			82654,	--Widow Venom 蜘蛛毒液
		},
		refresh = {1978},
	},
	["MAGE"] = {
		buffs = {
		},
		debuffs = {
			31589,	--Slow 减速术
			44457,	--Living Bomb 活动炸弹
		},
		refresh = {},
	},
	["PALADIN"] = {
		buffs = {
			53563,	--圣光道标
		},
		debuffs = {
		},
		refresh = {},
	},
	["PRIEST"] = {
		buffs = {
			139,	--Renew 恢复
		},
		debuffs = {
			589,	--ShadowWordPain 暗言术：痛
			2944, --Devouring Plague 噬灵瘟疫
			15286,	--Vampiric Embrace 吸血鬼的拥抱
			34914,	--Vampiric Touch 吸血鬼之触
		},
		refresh = {139, 589},
	},
	["ROGUE"] = {
		buffs = {
			5171,		--切割
		},
		debuffs = {
			1943,	--割裂
			8647, -- Expose Armor 破甲
		},
		refresh = {},
	},
	["SHAMAN"] = {
		buffs = {
			974,	--Earth Shield 大地之盾
			61295,	--Riptide 激流
		},
		debuffs = {
			8050,	--烈焰震击
		},
		refresh = {},
	},
	["WARLOCK"] = {
		buffs = {
			85383,	--Improved Soul Fire 强化灵魂之火
		},
		debuffs = {
			172,	--Corruption 腐蚀术
			603,	--Bane of Doom 末日灾祸
			980,	--Bane of Agony 痛苦灾祸
			80240,	--Bane of Havoc 浩劫灾祸
			18223,	--Curse of Exhaustion 疲劳诅咒
			1490,	--Curse of Elements 元素诅咒
			1714,	--Curse of Tongues 语言诅咒
			702,	--Curse of Weakness 虚弱诅咒
			348,	--Immolate 献祭
			710,	--Banish 放逐术
			5782,	--Fear 恐惧术
			6358,	--Seduction 诱惑
			27243,	--Seed of Corruption 腐蚀之种
			30108,	--Unstable Affliction 痛苦无常
			48181,	--Haunt 鬼影缠身
		},
		refresh = {172, 348, 30108}
	},
	["WARRIOR"] = {
		buffs = {
			6673,	--Battle Shout 战斗怒吼
			469,	--Commanding Shout 命令怒吼
		},
		debuffs = {
			772,	--Rend 撕裂
			1160,	--Demoralizing Shout 挫志怒吼
			12323,	--Piercing Howl 刺耳怒吼
			1715,	--Hamstring 断筋
			6343,	--Thunder Clap 雷霆一击
			7386,	--Sunder Armor 破甲攻击
			20243, -- Devastate 毁灭打击
		},
		refresh = {772},
	},
}
do
	local _, c = UnitClass("player")
	buffs, debuffs, refresh = data[c].buffs, data[c].debuffs, data[c].refresh
end

local tinsert = tinsert
local tremove = tremove
local strfind = strfind
local CreateFrame = CreateFrame
local UnitGUID = UnitGUID
local UnitBuff = UnitBuff
local UnitDebuff = UnitDebuff
local GetSpellInfo = GetSpellInfo
local GetActionTexture = GetActionTexture
local IsMouseOverKeyDown

local AppName, version, NewVersion = "DebuffCaster", 33
local slots, cds, ab, ad, focus, fbar = {}, {}, {}, {}, {b = {}, d = {}}
local sBuffs, sDebuffs = {}, {}
local defaults, profile, of, args, handler = {profile = {enable = true,
	castfix = false, mouseover = false, mouseoverkey = "none",
	show = {target = true, player = true},
	focus = {enable = true, p = "CENTER", x = 0, y = 0, scale = 1,
		n = 12, c = 12, lock = false, lockbtn}, buff = {}, debuff = {}}}
local L = setmetatable({}, {__index = function(t, i) return i end})
if GetLocale() == "zhCN" then
	L["Debuff"] = "负面效果"
	L["Cast time fix"] = "施法时间修正"
	L["Mouse over"] = "鼠标指向"
	L["Mouse over key"] = "鼠标指向键"
	L["None"] = "无"
	L["Focus bar"] = "焦点施法条"
	L["Lock"] = "锁定"
	L["Lock button"] = "锁定按钮"
	L["Hold shift to move spells"] = "按住shift移动技能"
	L["Reset position"] = "重置位置"
	L["Buttons"] = "按钮数"
	L["Columns"] = "列数"
	L["New version found"] = "发现新版本"
	L["Current version"] = "当前版本"
elseif GetLocale() == "zhTW" then
	L["Debuff"] = "負面效果"
	L["Cast time fix"] = "施法時間修正"
	L["Mouse over"] = "滑鼠指向"
	L["Mouse over key"] = "滑鼠指向鍵"
	L["None"] = "無"
	L["Focus bar"] = "焦點施法條"
	L["Lock"] = "鎖定"
	L["Lock button"] = "鎖定按鈕"
	L["Hold shift to move spells"] = "按住shift移動技能"
	L["Reset position"] = "重置位置"
	L["Buttons"] = "按鈕數"
	L["Columns"] = "列數"
	L["New version found"] = "發現新版本"
	L["Current version"] = "當前版本"
end

local occ = oCC
local dc = LibStub("AceAddon-3.0"):NewAddon(AppName, "AceEvent-3.0", "AceTimer-3.0", "LibConfig-1.0")

local function SetBuff(b, e)
	local tx, tx1, id, sid, _
	_, _, tx	= GetSpellInfo(b)
	ab[tx] = e and {s = 0, d = 0, c = b} or nil
	for i = 1, 144 do
		t, id, _, sid = GetActionInfo(i)
		if t == "macro" then
			tx1 = GetMacroSpell(id)
			if tx1 then _, _, tx1 = GetSpellInfo(tx1) end
		elseif t == "spell" then _, _, tx1 = GetSpellInfo(id)
		else tx1 = nil
		end
		if tx == tx1 then
			if e then
				tinsert(ab[tx], i) slots[i].s = tx
			else slots[i].s = nil
			end
		end
	end
	focus.b[tx] = e and {s = 0, d = 0, c = b} or nil
end

local function SetDebuff(d, e)
	local c, tx, tx1, id, sid, _
	_, _, tx, _, _, _, c	= GetSpellInfo(d)
	if c < 0 then d = nil end
	ad[tx] = e and {s = 0, d = 0, c = d} or nil
	for i = 1, 144 do
		t, id, _, sid = GetActionInfo(i)
		if t == "macro" then
			tx1 = GetMacroSpell(id)
			if tx1 then _, _, tx1 = GetSpellInfo(tx1) end
		elseif t == "spell" then _, _, tx1 = GetSpellInfo(id)
		else tx1 = nil
		end
		if tx == tx1 then
			if e then
				tinsert(ad[tx], i) slots[i].s = tx
			else slots[i].s = nil
			end
		end
	end
	focus.d[tx] = e and {s = 0, d = 0, c = d} or nil
end

local OnBtnTimer
local function SetFocusSpell(id, s)
	local n, r, t
	of[id] = s
	if s then
		n, r, t = GetSpellInfo(s)
		if n then
			fbar[id].spell = n
			local a = focus.d[t] or focus.b[t]
			if a then tinsert(a, id) end
		end
	end
	r = "Interface\\Buttons\\UI-Quickslot2"
	if not n then
		fbar[id].spell = nil
		local a = focus.d[n] or focus.b[n]
		if a then
			local i = 1
			while i <= #a do
				if a[i] == id then tremove(a, i) end
				i = i + 1
			end
		end
		n, r = "", "Interface\\Buttons\\UI-Quickslot"
	end
	fbar[id]:GetNormalTexture():SetTexture(r)
	fbar[id].icon:SetTexture(t)
	fbar[id]:SetAttribute("spell", n)
	dc:SPELL_UPDATE_COOLDOWN()
	OnBtnTimer()
end

handler = {
	enable = function(v)
		if v then dc:Enable() else dc:Disable() end
	end,
	mouseover = function(v)
		if v then
			dc:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
			dc:RegisterEvent("MODIFIER_STATE_CHANGED")
		else
			dc:UnregisterEvent("UPDATE_MOUSEOVER_UNIT")
			dc:UnregisterEvent("MODIFIER_STATE_CHANGED")
		end
	end,
	mouseoverkey = function(v)
		local f = {none = function() return true end,
			ctrl = IsCtrlKeyDown, alt = IsAltKeyDown, shift = IsShiftKeyDown}
		IsMouseOverKeyDown = f[v]
	end,
	buff = buffs and SetBuff or nil,
	debuff = SetDebuff,
	focus = {
		enable = function(v)
			if v then fbar:Show() else fbar:Hide() end
		end,
		lock = function(v)
			fbar:SetLock(v)
		end,
		n = function(v)
			fbar:Update()
		end,
		c = function(v)
			fbar:Update()
		end,
		scale = function(v)
			fbar:SetScale(v)
		end,
	}
}

args = {
	desc = {
		name = AppName.." r"..version,
		type = "description",
		order = 0,
	},
	enable = {
		name = ENABLE,
		type = "toggle",
		order = 10,
	},
	mouseover = {
		name = L["Mouse over"],
		type = "toggle",
		order = 20,
	},
	mouseoverkey = {
		name = L["Mouse over key"],
		type = "select",
		values = {none = L["None"], ctrl = "Ctrl",
			alt = "Alt", shift = "Shift",
		},
		order = 30,
	},
	castfix = {
		name = L["Cast time fix"],
		type = "toggle",
		order = 40,
	},
	buffs = buffs and {
		name = BUFFERING,
		type = "group",
		order = 50,
		args = {
			buff = buffs and {
				name = BUFFERING,
				type = "multiselect",
				values = sBuffs,
				order = 10,
			},
		},
	} or nil,
	debuffs = {
		name = L["Debuff"],
		type = "group",
		order = 60,
		args = {
			debuff = {
				name = L["Debuff"],
				type = "multiselect",
				values = sDebuffs,
				order = 10,
			},
		},
	},
	focus = {
		name = L["Focus bar"],
		type = "group",
		order = 70,
		args = {
			enable = {
				name = ENABLE,
				type = "toggle",
				order = 10,
			},
			lock = {
				name = L["Lock"],
				type = "toggle",
				order = 20,
			},
			lockbtn = {
				name = L["Lock button"],
				desc = L["Hold shift to move spells"],
				type = "toggle",
				order = 30,
			},
			resetpos = {
				name = L["Reset position"],
				type = "execute",
				order = 40,
				func = function()
					of.p, of.x, of.y = "CENTER", 0, 0
					fbar.a:Update()
				end,
			},
			n = {
				name = L["Buttons"],
				type = "range",
				min = 1,
				max = 12,
				step = 1,
				order = 50,
			},
			c = {
				name = L["Columns"],
				type = "range",
				min = 1,
				max = 12,
				step = 1,
				order = 60,
			},
			scale = {
				name = L["Scale"],
				type = "range",
				min = 0.5,
				max = 2,
				step = 0.05,
				order = 70,
			},
		},
	},
	--[[list = {
		name = "List",
		type = "execute",
		order = 100,
		func = function()	--for debug
			local lt, n
			if ab then
				print("Buffs")
				for s, a in pairs(ab) do
					print(s, #a)
					for i = 1, #a do
						print("slot "..a[i])
						for j = 1, #slots[a[i] ] do
							print("   "..j..": "..slots[a[i] ][j]:GetName())
						end
					end
				end
			end
			print("Debuffs")
			for t, a in pairs(ad) do
				print(t, #a)
				for i = 1, #a do
					print("slot "..a[i])
					for j = 1, #slots[a[i] ] do
						print("   "..j..": "..slots[a[i] ][j]:GetName())
					end
				end
			end
		end
	},]]
}

local function UpdateSlot(slot)
	local a, e
	if slots[slot].s then a = ad[slots[slot].s] or ab[slots[slot].s]
	else a = {s = 0, d = 0}
	end
	e = a.s > 0 and 1 or 0
	for i = 1, #slots[slot] do
		local c, _ = 0
		if profile.castfix and a.c then
			_, _, _, _, _, _, c	= GetSpellInfo(a.c)
		end
		if c < 0 then c = 0 end
		CooldownFrame_SetTimer(slots[slot][i], a.s - c / 1000, a.d, e)
	end
end

--[[function ad:UpdateFocus()

end

function ab:UpdateFocus()

end

function unit:SetBuff(n, set)
	if set then
		local d, et, m, _
		n, _, _, _, _, d, et, m = UnitBuff(self.unit, n, nil, "PLAYER")
		if m then
			for _, v in ipairs(self.buff) do
				CooldownFrame_SetTimer(fbar[v].lt, et - d, d, e)
			end
	else

	end
end

function focus:SetDebuff(n)

end
]]

local function UpdateFocus(a)
	local e = a.s > 0 and 1 or 0
	for i = 1, #a do
		local c, _ = 0
		if profile.castfix and a.c then
			_, _, _, _, _, _, c	= GetSpellInfo(a.c)
		end
		if c < 0 then c = 0 end
		CooldownFrame_SetTimer(fbar[a[i]].lt, a.s - c / 1000, a.d, e)
	end
end

local function UpdateMainBar()
	for i = 1, 144 do
		local slot, j, a, f, p = slots[i], 1
		while j <= #slot do
			p = slot[j]:GetParent()
			a = p:GetAttribute("action") or p.action
			if a ~= i then
				tinsert(slots[a], slot[j])
				tremove(slot, j)
				f = true
			else j = j + 1
			end
		end
		if f then UpdateSlot(a) end
	end
end

local function UpdateSpell(a)
	for i = 1, #a do UpdateSlot(a[i]) end
end

local function UpdateBuff(unit)
	for tx, a in pairs(ab) do
		local f
		for i = 1, 40 do
			local d, et, tx1, id, _
			_, _, tx1, _, _, d, et, _, _, _, id = UnitBuff(unit, i, "PLAYER")
			if not tx1 then break end
			if tx == tx1 then
				a.s, a.d, a.c, f = et - d, d, id, true
				break
			end
		end
		if not f and a.s > 0 then
			a.s, a.d, f = 0, 0, true
		end
		if f then UpdateSpell(a) end
	end
end

local function UpdateUnit(unit)
	if ab then
		UpdateBuff("player")
		if UnitIsFriend("player", unit) and not UnitIsUnit("player", unit) then
			UpdateBuff(unit)
		end
	end
	if UnitCanAttack("player", unit) then
		for tx, a in pairs(ad) do
			local f
			for i = 1, 40 do
				local d, et, tx1, id, _
				_, _, tx1, _, _, d, et, _, _, _, id = UnitDebuff(unit, i, "PLAYER")
				if not tx1 then break end
				if tx == tx1 then
					a.s, a.d, a.c, f = et - d, d, id, true
					break
				end
			end
			if not f and a.s > 0 then
				a.s, a.d, f = 0, 0, true
			end
			if f then UpdateSpell(a) end
		end
	end
end

local function SetTimer(self, start, duration, enable)
	if self.DCFlag then return end
	local p, a, m = self:GetParent()
	if p and p:IsObjectType("CheckButton") and (p:GetAttribute("type")
		== "action" or p:GetAttribute("type") == "click") then
		a = p:GetAttribute("action") or p.action
		if a and a > 0 and a <= 144 then
			self.DCFlag = true
			if not cds[self] then
				local lt = CreateFrame("cooldown", p:GetName().."LeftTime", p)
				lt.DCFlag = true
				lt:SetReverse(true)
				lt:SetFrameLevel(self:GetFrameLevel())
				lt:SetAllPoints(self)
				cds[self] = lt
			end
			tinsert(slots[a], cds[self])
		end
	end
end
hooksecurefunc("CooldownFrame_SetTimer", SetTimer)

local NeedUpdate
local function UpdateActionBar()
	if buffs then
		wipe(ab)
		for i, v in pairs(buffs) do
			SetBuff(v, profile.buff[v])
		end
	end
	wipe(ad)
	for i, v in pairs(debuffs) do
		SetDebuff(v, profile.debuff[v])
	end
	for i = 1, 144 do UpdateSlot(i) end
	if InCombatLockdown() then NeedUpdate = true
	else
		for i = 1, 12 do
			SetFocusSpell(i, of[i])
		end
	end
end

--Anchor
local function OnAnchorMouseDown(self, btn)
	if btn == "LeftButton" then
		self:StartMoving()
		self.moving = true
	end
end

local function OnAnchorMouseUp(self, btn)
	if self.moving then
		self:StopMovingOrSizing()
		self.moving = false
		local p, x, y, _
		if self.OnMoved then
			p, _, _, x, y = self:GetPoint()
			self:OnMoved(p, x, y)
		end
	end
end

local function CreateAnchor(w, h, text, parent)
	local a, t = CreateFrame("Frame", nil, parent)
	a:SetWidth(w) a:SetHeight(h)
	a:SetScript("OnMouseDown", OnAnchorMouseDown)
	a:SetScript("OnMouseUp", OnAnchorMouseUp)
	a:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 16, edgeSize = 16,
		insets = {left = 5, right = 5, top = 5, bottom = 5}
	})
	a:SetBackdropBorderColor(1, 1, 1)
	a:SetBackdropColor(0.1, 0.1, 0.1)
	a:SetMovable(true) a:EnableMouse(true)
	t = a:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	t:SetAllPoints(a)
	t:SetText(text)
	a.label = t
	return a
end

local function OnBtnDragStart(self)
	if InCombatLockdown() or of.lockbtn and not IsShiftKeyDown() then
		return
	end
	local id = of[self.id]
	if id then
		SetFocusSpell(self.id)
		PickupSpell(id)
	end
end

local function OnBtnReceiveDrag(self)
	if InCombatLockdown() then return end
	local t, id, s = GetCursorInfo()
	if t == "spell" then
		ClearCursor()
		t = GetSpellLink(id, s)
		id = tonumber(t:match("spell:(%d+)"))
		if of[self.id] then
			PickupSpell(of[self.id])
			SetFocusSpell(self.id)
		end
		dc:ScheduleTimer(function()
			SetFocusSpell(self.id, id)
		end, 0.1)
	end
end

local function OnBtnMouseUp(self, btn)
	if btn == "LeftButton" and CursorHasSpell() then
		OnBtnReceiveDrag(self)
	end
end

local function OnBtnEnter(self)
	if GetCVar("UberTooltips") == "1" then
		GameTooltip_SetDefaultAnchor(GameTooltip, self)
	else GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
	end
	if of[self.id] and GameTooltip:SetHyperlink(
		"spell:"..of[self.id]) then
		self.UpdateTooltip = OnBtnEnter
	else self.UpdateTooltip = nil
	end
end

local function OnBtnLeave(self)
	GameTooltip:Hide()
end

local function CreateButton(id, parent)
	local n, b, t = "DCBtn"..id
	b = CreateFrame("CheckButton", n, parent, "SecureActionButtonTemplate")
	b:SetSize(36, 36)
	t = b:CreateTexture(n.."Icon", "BACKGROUND")
	t:SetAllPoints(b)
	b.icon, b.id = t, id
	b:SetPushedTexture("Interface\Buttons\UI-Quickslot-Depress")
	b:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square", "ADD")
	b:SetNormalTexture("Interface\\Buttons\\UI-Quickslot")
	b:GetNormalTexture():SetTexCoord(0.15, 0.85, 0.15, 0.85)
	t = CreateFrame("Cooldown", n.."Cooldown", b)
	t:SetAllPoints(b)
	t.DCFlag = true
	b.cd = t
	t = CreateFrame("Cooldown", n.."LeftTime", b)
	t:SetReverse(true)
	t:SetAllPoints(b)
	t.DCFlag = true
	b.lt = t
	b:SetAttribute("type", "spell")
	b:SetAttribute("unit", "focus")
	b:RegisterForDrag("LeftButton")
	b:SetScript("OnDragStart", OnBtnDragStart)
	b:SetScript("OnMouseUp", OnBtnMouseUp)
	b:SetScript("OnReceiveDrag", OnBtnReceiveDrag)
	b:SetScript("OnEnter", OnBtnEnter)
	b:SetScript("OnLeave", OnBtnLeave)
	return b
end

fbar = CreateFrame("Frame", "DCFocusBar", UIParent, "SecureHandlerStateTemplate")
fbar.a = CreateAnchor(120, 30, L["Focus bar"], fbar)
fbar:SetAllPoints(fbar.a)

function fbar:SetLock(lock)
	if lock then self.a:Hide()
	else self.a:Show()
	end
end

for i = 1, 12 do
	fbar[i] = CreateButton(i, fbar)
end
fbar.n = 12

function fbar.a:OnMoved(p, x, y)
	of.p, of.x, of.y = p, x, y
end

function fbar.a:Update()
	self:ClearAllPoints()
	self:SetPoint(of.p, UIParent, of.p, of.x, of.y)
end

function fbar:Update()
	for i = self.n + 1, of.n do
		self[i]:Show()
	end
	for i = of.n + 1, self.n do
		self[i]:Hide()
	end
	self.n = of.n
	for i = 1, of.n do
		self[i]:SetPoint("TOPLEFT", self.a, "BOTTOMLEFT",
			(i - 1) % of.c * 36, -floor((i - 1) / of.c) * 36)
	end
end

OnBtnTimer = function()
	for i = 1, 12 do
		local r, g, b = 1, 1, 1
		if fbar[i].spell then
			if IsSpellInRange(fbar[i].spell, "focus") == 0 then
				g, b = 0, 0
			else
				local u, m = IsUsableSpell(fbar[i].spell)
				if m then r, g = 0.4, 0.4
				elseif not u then r, g, b = 0.4, 0.4, 0.4
				end
			end
		end
		fbar[i].icon:SetVertexColor(r, g, b)
	end
end

local tmrBtn = dc:ScheduleRepeatingTimer(OnBtnTimer, 0.2)

local function OnVersion(sender, addon, v)
	v = tonumber(v:match("%d+"))
	if v > NewVersion then
		print("|cff00ff00DebuffCaster "..L["New version found"]..": r"..v)
		print("|cffff0000DebuffCaster "..L["Current version"]..": r"..version)
		NewVersion = v
	end
end

function dc:OnProfileChanged(event, db, name)
	profile = db.profile
	of = profile.focus
end

function dc:OnLoaded()
	fbar.a:Update()
	self:ScheduleTimer(function()
		UpdateActionBar()
		dc:RegisterEvent("ACTIONBAR_SLOT_CHANGED")
		dc:RegisterEvent("ACTIONBAR_PAGE_CHANGED")
		dc:RegisterEvent("VEHICLE_UPDATE")
		dc:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		dc:RegisterEvent("CONFIRM_TALENT_WIPE")
		dc:RegisterEvent("PLAYER_REGEN_ENABLED")
		dc:RegisterEvent("UNIT_AURA")
		local _, c = UnitClass("player")
		if c == "DRUID" then
			dc:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
		end
	end, 2)
end

function dc:SPELL_UPDATE_COOLDOWN()
	for i = 1, 12 do
		if of[i] then
			CooldownFrame_SetTimer(fbar[i].cd, GetSpellCooldown(of[i]))
		end
	end
end

dc:RegisterEvent("SPELL_UPDATE_COOLDOWN")

function dc:OnInitialize()
	if buffs then
		for i, v in ipairs(buffs) do
			sBuffs[v] = GetSpellInfo(v)
			defaults.profile.buff[v] = true
		end
	end
	for i, v in ipairs(debuffs) do
		sDebuffs[v] = GetSpellInfo(v)
		defaults.profile.debuff[v] = true
	end
	for i = 0, 144 do
		slots[i] = {}
	end
	self:CreateOptions(AppName, args, handler, "dc", "DebuffCasterDB", defaults)
	NewVersion = version
	LibStub("LibVersionCheck-1.0"):RegisterVersion(AppName, tostring(version), OnVersion)
end

function dc:OnEnable()
	dc:RegisterEvent("PLAYER_TARGET_CHANGED")
	dc:RegisterEvent("PLAYER_FOCUS_CHANGED")
	if profile.mouseover then
		dc:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
		dc:RegisterEvent("MODIFIER_STATE_CHANGED")
	end
	dc:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function dc:OnDisable()
	dc:UnregisterEvent("UNIT_TARGET")
	if profile.mouseover then
		dc:UnregisterEvent("UPDATE_MOUSEOVER_UNIT")
		dc:UnregisterEvent("MODIFIER_STATE_CHANGED")
	end
	dc:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function dc:ACTIVE_TALENT_GROUP_CHANGED()
	self:ScheduleTimer(function()
		for cd, _ in pairs(cds) do
			cd.DCFlag = nil
		end
		for i = 1, 144 do
			slots[i].s = nil
			for j = 1, #slots[i] do tremove(slots[i]) end
		end
		UpdateActionBar()
	end, 0.2)
end

function dc:CONFIRM_TALENT_WIPE()
	self:ACTIVE_TALENT_GROUP_CHANGED()
end

function dc:ACTIONBAR_SLOT_CHANGED(event, slot)
	local t, id, _, sid, tx = GetActionInfo(slot)
	if t == "macro" then
		tx = GetMacroSpell(id)
		if tx then _, _, tx = GetSpellInfo(tx) end
	elseif t == "spell" then _, _, tx = GetSpellInfo(id)
	end
	if slots[slot].s then
		local a = ad[slots[slot].s] or ab[slots[slot].s]
		if a.s > 0 then f = true end
		for i = 1, #a do
			if a[i] == slot then tremove(a, i) break end
		end
		slots[slot].s = nil
	end
	if tx then
		local a = ad[tx] or ab and ab[tx]
		if a then
			tinsert(a, slot)
			slots[slot].s = tx
			if a.s > 0 then f = true end
		end
	end
	if f then UpdateSlot(slot) end
end

function dc:ACTIONBAR_PAGE_CHANGED()
	self:ScheduleTimer(UpdateMainBar, 0.02)
end

function dc:UPDATE_SHAPESHIFT_FORM()
	self:ScheduleTimer(UpdateMainBar, 0.02)
end

function dc:VEHICLE_UPDATE(event, unit)
	self:ScheduleTimer(UpdateMainBar, 0.1)
	self:PLAYER_TARGET_CHANGED()
end

function dc:PLAYER_TARGET_CHANGED()
	if UnitExists("target") then
		UpdateUnit("target")
	else
		for t, a in pairs(ad) do
			if a.s > 0 then
				a.s, a.d = 0, 0
				UpdateSpell(a)
			end
		end
		if ab then UpdateBuff("player") end
	end
end

function dc:PLAYER_FOCUS_CHANGED()
	if UnitExists("focus") then
		if UnitCanAttack("player", "focus") then
			for tx, a in pairs(focus.d) do
				local f
				for i = 1, 40 do
					local d, et, tx1, id, _
					_, _, tx1, _, _, d, et, _, _, id = UnitDebuff("focus", i, "PLAYER")
					if not tx1 then break end
					if tx == tx1 then
						a.s, a.d, a.c, f = et - d, d, id, true
						break
					end
				end
				if not f and a.s > 0 then
					a.s, a.d, f = 0, 0, true
				end
				if f then UpdateFocus(a) end
			end
		else
			for tx, a in pairs(focus.b) do
				for i = 1, 40 do
					local d, et, tx1, id, _
					_, _, tx1, _, _, d, et, _, _, _, id = UnitBuff("focus", i, "PLAYER")
					if not tx1 then break end
					if tx == tx1 then
						a.s, a.d, a.c, f = et - d, d, id, true
						break
					end
				end
				if not f and a.s > 0 then
					a.s, a.d, f = 0, 0, true
				end
				if f then UpdateFocus(a) end
			end
		end
	else
		for tx, a in pairs(focus.b) do
			if a.s > 0 then
				a.s, a.d = 0, 0
				UpdateFocus(a)
			end
		end
		for tx, a in pairs(focus.d) do
			if a.s > 0 then
				a.s, a.d = 0, 0
				UpdateFocus(a)
			end
		end
	end
end

function dc:PLAYER_REGEN_ENABLED()
	if NeedUpdate then
		for i = 1, 12 do
			SetFocusSpell(i, of[i])
		end
	end
end

local tmrMouseOver
local function OnUpdateMouseOver()
	if not UnitExists("mouseover") then
		dc:CancelTimer(tmrMouseOver)
		dc:PLAYER_TARGET_CHANGED()
		tmrMouseOver = nil
	end
end

function dc:UPDATE_MOUSEOVER_UNIT()
	if IsMouseOverKeyDown() then
		if not tmrMouseOver then
			tmrMouseOver = self:ScheduleRepeatingTimer(OnUpdateMouseOver, 0.2)
		end
		UpdateUnit("mouseover")
	end
end

function dc:MODIFIER_STATE_CHANGED(event, key, state)
	if key:lower():find(profile.mouseoverkey) and UnitExists("mouseover") then
		if state == 1 then
			if not tmrMouseOver then
				tmrMouseOver = self:ScheduleRepeatingTimer(OnUpdateMouseOver, 0.2)
			end
			UpdateUnit("mouseover")
		elseif tmrMouseOver then
			dc:CancelTimer(tmrMouseOver)
			dc:PLAYER_TARGET_CHANGED()
			tmrMouseOver = nil
		end
	end
end


function dc:UNIT_AURA(event, unit)
	if unit == "target" then

	end
end

local function GetActionState(u, id, a, b)
	local n, r, tx, d, e = GetSpellInfo(id)
	a = a[tx]
	if a then
		b = b and UnitBuff or UnitDebuff
		_, _, _, _, _, d, e = b(u, n, r, "PLAYER")
		if d then
			a.s, a.d, a.c = e - d, d, id
			return a
		end
	end
end

local function OnRefresh()
	for _, id in ipairs(refresh) do
		local p, a = UnitExists("target") and "target" or "player"
		a = GetActionState(p, id, ad)
		if not a then a = GetActionState(p, id, ab, true) end
		if a then UpdateSpell(a) end
		if UnitExists("focus") then
			a = GetActionState("focus", id, focus.d)
			if not a then a = GetActionState("focus", id, focus.b, true) end
			if a then UpdateFocus(a) end
		end
	end
end

local tmrRefresh = dc:ScheduleRepeatingTimer(OnRefresh, 1)

function dc:COMBAT_LOG_EVENT_UNFILTERED(_, _, eventType, _, srcGUID, srcName, _, _,
	dstGUID, dstName, _, _, spellID, spellName, _, spellType)
	local pid, pt, tid, fid, mid = UnitGUID("player"), UnitGUID("pet"),
		UnitGUID("target"), UnitGUID("focus"), UnitGUID("mouseover")
	if srcGUID ~= pid and srcGUID ~= pt or dstGUID ~= pid and dstGUID ~= pt and dstGUID ~= tid and
		dstGUID ~= fid and dstGUID ~= mid then return end
	local a, tx, d, et, id
	if eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_REFRESH" or
		eventType == "SPELL_AURA_APPLIED_DOSE" or eventType == "SPELL_AURA_REMOVED_DOSE" then
		if spellType == "DEBUFF" then
			if dstGUID == mid then
				_, _, tx, _, _, d, et = UnitDebuff("mouseover", spellName, nil, "PLAYER")
				a = ad[tx]
				if a then
					a.s, a.d, a.c = et - d, d, spellID
					UpdateSpell(a)
					if not tmrMouseOver and IsMouseOverKeyDown() then
						tmrMouseOver = self:ScheduleRepeatingTimer(OnUpdateMouseOver, 0.2)
					end
				end
			elseif dstGUID == tid then
				_, _, tx, _, _, d, et = UnitDebuff("target", spellName, nil, "PLAYER")
				a = ad[tx]
				if a then
					a.s, a.d, a.c = et - d, d, spellID
					UpdateSpell(a)
				end
			end
			if dstGUID == fid then
				_, _, tx, _, _, d, et = UnitDebuff("focus", spellName, nil, "PLAYER")
				a = focus.d[tx]
				if a then
					a.s, a.d, a.c = et - d, d, spellID
					UpdateFocus(a)
				end
			end
		elseif ab and spellType == "BUFF" then
			if dstGUID == fid then
				_, _, tx, _, _, d, et = UnitBuff("focus", spellName, nil, "PLAYER")
				a = focus.b[tx]
				if a then
					a.s, a.d, a.c = et - d, d, spellID
					UpdateFocus(a)
				end
			else
				local tar
				if UnitControllingVehicle("player") and dstGUID == pt then tar = "pet"
				else tar = dstGUID == tid and "target" or "player"
				end
				_, _, tx, _, _, d, et = UnitBuff(tar, spellName, nil, "PLAYER")
				a = ab[tx]
				if a then
					a.s, a.d, a.c = et - d, d, spellID
					UpdateSpell(a)
				end
			end
		end
	elseif eventType == "SPELL_AURA_REMOVED" then
		_, _, tx = GetSpellInfo(spellID)
		a = ad[tx] or ab and ab[tx]
		if a and a.s > 0 then
			a.s, a.d = 0, 0
			if dstGUID == tid or dstGUID == pid or
				UnitControllingVehicle("player") and dstGUID == pt then
				UpdateSpell(a)
			end
			if occ then occ:ShowShine(tx) end
		end
		a = focus.d[tx] or focus.b[tx]
		if a and a.s > 0 then
			a.s, a.d = 0, 0
			if dstGUID == fid then UpdateFocus(a) end
			if occ then occ:ShowShine(tx) end
		end
	end
end

dc.ab, dc.ad, dc.slots, dc.focus = ab, ad, slots, focus
DebuffCaster = dc
